﻿@model RealEstate.Models.UserModel


<div class="row _user_Bank">
    <div class="col-xl-12 ">
        <div class="card bg-white text-black mb-1">
            @*<div class="card-header text-left">
                    Bank Detail
                </div>*@
            <div class="card-body text-center">

                <div class="row" style="margin-top:1em;">
                    <div class="col-sm-6">
                        <div class="form-group">
                            @Html.LabelFor(model => model.UserLeaveDetail.Leave_Allocated, htmlAttributes: new { @class = "control-label col-md-5 text-left" })
                            <div class="col-md-7 float-right">
                                @Html.EditorFor(model => model.UserLeaveDetail.Leave_Allocated, new { htmlAttributes = new { @class = "form-control", disabled = "disabled" } })
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="form-group">
                            @Html.LabelFor(model => model.UserLeaveDetail.Leave_Taken, htmlAttributes: new { @class = "control-label col-md-5 text-left" })
                            <div class="col-md-7 float-right">
                                @Html.EditorFor(model => model.UserLeaveDetail.Leave_Taken, new { htmlAttributes = new { @class = "form-control", disabled = "disabled" } })
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row" style="margin-top:1em;">
                    <div class="col-sm-6">
                        <div class="form-group">
                            @Html.LabelFor(model => model.UserLeaveDetail.Worked_On_Holiday, htmlAttributes: new { @class = "control-label col-md-5 text-left" })
                            <div class="col-md-7 float-right">
                                @Html.EditorFor(model => model.UserLeaveDetail.Worked_On_Holiday, new { htmlAttributes = new { @class = "form-control", disabled = "disabled" } })
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="form-group">
                            @Html.LabelFor(model => model.UserLeaveDetail.Remaining_Leave, htmlAttributes: new { @class = "control-label col-md-5 text-left" })
                            <div class="col-md-7 float-right">
                                @Html.EditorFor(model => model.UserLeaveDetail.Remaining_Leave, new { htmlAttributes = new { @class = "form-control", disabled = "disabled" } })
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>


<div class="row _user_Bank">
    <div class="col-xl-12 ">
        <div class="card bg-white text-black mb-1">
            @*<div class="card-header text-left">
                    Bank Detail
                </div>*@
            <div class="card-body text-center">
                <div id="UserCalendar"></div>

            </div>
        </div>
    </div>
</div>




<script type="text/javascript">
    var data = {
        UserId: "",
        IsPresent: false,
        Date: "",
        Remarks: "",
        Location: "Geolocation is disabled",
        LeaveId: null,
        IsApproved: null
    };
    var MA_Leave_Lst_Arr;
    var MA_Leave_Lst;

    $(document).ready(function () {
        LoadCalender();

        $("#li_Ad").click(function () {
            showloader(true);
            setTimeout(function () {
                $('#UserCalendar').fullCalendar('prev');
                $('#UserCalendar').fullCalendar('next');
                showloader(false);
            },1000)
        })
    });


    function LoadCalender() {
        data.UserId = @Model.Id;

        $('#UserCalendar').fullCalendar({
            header:
            {
                left: 'prev,next today',
                center: 'title',
                right: 'month'//',agendaWeek,agendaDay'
            },
            buttonText: {
                today: 'Today',
                month: 'Month',
                //week: 'week',
                //day: 'day'
            },
            events: function (start, end, timezone, callback) {
                $.ajax({
                    url: '/Attendence/GetAttendence?UserId=' + data.UserId,
                    type: "GET",
                    dataType: "JSON",
                    success: function (result) {
                        MA_Leave_Lst_Arr = _.where(result.MA_Leave_Lst, { IsPaid: false })
                        var user_leave_option = _.filter(result.MA_Leave_Lst, function (leave) {
                            return leave.IsPaid != false;
                        });
                        MA_Leave_Lst = "<option value='0'>---Select Leave Code---</option>"
                        $.each(user_leave_option, function (key, value) {
                            MA_Leave_Lst += "<option value=" + value.Id + ">" + value.Name + "</option>";
                        });


                        var events = [];

                         //--------------User Holiday----------------
                        $.each(result.UserAttendences, function (i, data) {
                            var d = new Date(parseInt(data.Date.substr(6)));
                            var formatted_date = moment([d.getFullYear(), (d.getMonth() + 1), d.getDate()].join('-')).format('YYYY-MM-DD')
                            events.push(
                                {
                                    title: data.Leave_Name,
                                    description: "Location : " + data.Location + " </br></br>Remarks: " + data.Remarks,
                                    start: formatted_date,
                                    end: formatted_date,
                                    backgroundColor:  "#fff",
                                    borderColor: "none",
                                    className: data.IsPresent ? ["bg-success"] : data.IsApproved == null ? ["bg-unapproved-leave"] : data.IsApproved ? ["bg-absent"] : ["bg-rejected-leave"]
                                });
                        });

                        //--------------Company Holiday----------------
                        $.each(MA_Leave_Lst_Arr, function (i, data) {
                            var start = new Date(parseInt(data.FromDate.substr(6)));
                            var formatted_start = moment([start.getFullYear(), (start.getMonth() + 1), start.getDate()].join('-')).format('YYYY-MM-DD')
                            var end = new Date(parseInt(data.ToDate.substr(6)));
                            var formatted_end = moment([end.getFullYear(), (end.getMonth() + 1), end.getDate()].join('-')).format('YYYY-MM-DD')

                            events.push(
                                {
                                    title: data.Name,
                                    description: data.Name,
                                    start: formatted_start,
                                    end: formatted_end,
                                    backgroundColor: "#ffff",
                                    borderColor: "none",
                                    className: ["bg-primary"]
                                });
                        });
                        callback(events);
                    }
                });
            },
            eventRender: function (event, element) {
                element.qtip(
                    {
                        content: event.description
                    });
            },
            eventClick: function (calEvent, jsEvent, view) {
                data.Date = calEvent.start._i;
                OpenPopUp(data, $(this));
            },
            dayClick: function (date, jsEvent, view) {

                data.Date = date.format();
                OpenPopUp(data, $(this))
            },
            dayRender: function (date, cell) {
                cell.css("background", "#ffffff");
                //var data = User_Attendence_Data;
                //var today = $.fullCalendar.moment();
                //var end = $.fullCalendar.moment().add(1, 'days');
                //if (date.get('date') == today.get('date')) {
                //    cell.css("background", "blue");
                //}
            },
            editable: false,
            //selectable: true,
            //select: function (start, end, jsEvent, view) {
            //    console.log(start)
            //    console.log(end)
            //    $("#UserCalendar").fullCalendar('addEventSource', [{
            //        start: start,
            //        end: end,
            //        rendering: 'background',
            //        block: true,
            //    },]);
            //    $("#UserCalendar").fullCalendar("unselect");
            //},
            //selectOverlap: function (event) {
            //   // return !event.block;
            //}
        });
    }

    function OpenPopUp(data, e) {
        return false;

        var date = data.Date;
        var d = new Date();
        var today = moment([d.getFullYear(), (d.getMonth() + 1), d.getDate()].join('-')).format('YYYY-MM-DD')

        if (date < today) {
            return false;
        }

        $.confirm({
            closeIcon: true,
            closeIconClass: 'fa fa-close',
            title: 'Mark Present ?',
            content: '' +
                '<form action="" class="formName">' +
                '<div class="form-group">' +
                '<select class="leave form-control">' + MA_Leave_Lst + '<select></br>' +
                '</div>' +
                '</form>',
            buttons: {
                    formSubmit: {
                        text: 'PRESENT',
                    btnClass: (date > today) ? "btn-success hide" :"btn-success",
                                action: function () {
                                    data.IsPresent = true;
                                    data.LeaveId = null;
                                    SetAttendence(data);
                                }
                    },

                ApplyForLeave: {
                    text: 'Apply For Leave',
                    btnClass: 'btn-danger',
                    action: function () {
                        data.LeaveId = this.$content.find('.leave option:selected').val();
                        if (data.LeaveId == 0) {
                            alert("Select leave code to proceed")
                            return false;
                        }
                        data.IsPresent = false;
                        SetAttendence(data);
                    }
                },
                cancel:  {
                    btnClass: 'btn-primary'
                },
            },
            onContentReady: function () {
                var jc = this;
                this.$content.find('form').on('submit', function (e) {
                    e.preventDefault();
                    jc.$$formSubmit.trigger('click');
                });
            }
        });
    }
    function getLocation(data) {

        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(Get_Location_Name, showError);
        } else {
            data.Location = "Geolocation is not supported by this browser.";
            SetAttendence(data)
        }
    }
    function showError(error) {
        switch (error.code) {
            case error.PERMISSION_DENIED:
                $.notify("Your geolocation is disabled. Enable it to capture location.", 'info');
                data.Location = "Geolocation Disabled";
                SetAttendence(data)
                //var resp = confirm("Proceed without geolocation.")
                //if (resp == true) {
                //    data.Location = "Geolocation Disabled";
                //    SetAttendence(data)
                //} else {
                //    $('#UserCalendar').fullCalendar('prev');
                //    $('#UserCalendar').fullCalendar('next');
                //}
                break;
            case error.POSITION_UNAVAILABLE:
                alert("Location information is unavailable.")
                break;
            case error.TIMEOUT:
                alert("The request to get user location timed out.")
                break;
            case error.UNKNOWN_ERROR:
                alert("An unknown error occurred.")
                break;
        }
    }
    function Get_Location_Name(position) {
        $.ajax({
            url: 'https://api.opencagedata.com/geocode/v1/json?q=' + position.coords.latitude + '+' + position.coords.longitude + '&key=d3431fc7c75e46beb78e54d0a390b337',
            type: "GET",
            dataType: "JSON",
            success: function (result) {
                if (result.status.code == 200) {
                    data.Location = result.results[0].formatted
                }
                SetAttendence(data)
            },
            error: function () {
                SetAttendence(data)
            }
        });
    }
    function SetAttendence(data) {
        showloader(true);
        $.ajax({
            url: '/Attendence/SetAttendence?IsAdmin=0',
            type: "POST",
            dataType: "JSON",
            data: data,
            success: function (result) {
                showloader(false);
                $.notify(result.Data, 'info');
                $('#UserCalendar').fullCalendar('prev');
                $('#UserCalendar').fullCalendar('next');
                //window.location.href = window.location.href;
            },
            error: function (jqXHR, exception) {
                showloader(false);
                $.notify("Some error occured, contact administrator", 'info');
            }
        });
    }
</script>